unit Uestamp5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm5 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    UpDown1: TUpDown;
    Label2: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    BitBtn1: TBitBtn;
    ColorDialog1: TColorDialog;
    BitBtn2: TBitBtn;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    Panel2: TPanel;
    Label5: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    RadioGroup1: TRadioGroup;
    Image1: TImage;
    procedure Panel1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure Degrader(acanvas : Tcanvas; arect : Trect);
  end;

var
  Form5: TForm5;

implementation

{$R *.DFM}

procedure TForm5.RadioGroup1Click(Sender: TObject);
begin
  degrader(image1.canvas, rect(0,0, 256,256));
end;

// choix des couleurs
procedure TForm5.Panel1Click(Sender: TObject);
begin
  if colordialog1.execute then (sender as Tpanel).color := colordialog1.color;
  If sender = panel3 then panel1.color := panel3.color;
  degrader(image1.canvas, rect(0,0, 256,256));
end;

Procedure Tform5.degrader(acanvas : Tcanvas; arect : Trect);
Var
  i    : integer;
  R1, G1, B1  : integer;
  R, G, B     : integer;
  R2, G2, B2  : integer;
  cx, cy : integer;
  x1, y1, x2, y2 : integer;
  aw, ah : integer;
begin
  aw := arect.right - arect.left;
  ah := arect.bottom - arect.top;
  if (aw < 2) or (ah < 2) then exit;
  acanvas.brush.style := bssolid;        // peinture du fond
  acanvas.pen.width := 1;
  acanvas.brush.color := panel1.color;
  acanvas.fillrect(arect);
  if radiogroup1.itemindex = 0 then exit;
  cx := arect.left+aw div 2;
  cy := arect.top +ah div 2;
  R1 := GetRValue(ColorToRGB(Panel2.Color));       // start color
  G1 := GetGValue(ColorToRGB(Panel2.Color));
  B1 := GetBValue(ColorToRGB(Panel2.Color));
  R2 := GetRValue( ColorToRGB(panel3.Color)) - R1; // deltacolor
  G2 := GetgValue( ColorToRGB(panel3.Color)) - G1;
  B2 := GetbValue( ColorToRGB(panel3.Color)) - B1;
  Case radiogroup1.itemindex of
  1: begin
       y1 := Arect.top;
       y2 := Arect.bottom;
       For i:= 0 To aw Do
       Begin
         x1 := arect.left + i;
         R := (R1+ (i * R2) div aw) mod 256;
         G := (G1+ (i * G2) div aw) mod 256;
         B := (B1+ (i * B2) div aw) mod 256;
         With ACanvas Do begin
           pen.color:=RGB(R, G, B);
           moveto(x1,y1); lineto(x1,y2);
         end;
       end;
     end;
  2: begin
       y1 := Arect.top;
       y2 := Arect.bottom;
       aw := aw div 2;
       For i:= 0 To aw Do
       Begin
         x1 := arect.left + cx + i;
         x2 := arect.left + cx - i;
         R := (R1+ (i * R2) div aw) mod 256;
         G := (G1+ (i * G2) div aw) mod 256;
         B := (B1+ (i * B2) div aw) mod 256;
         With ACanvas Do begin
           pen.color:=RGB(R, G, B);
           moveto(x1,y1); lineto(x1,y2);
           moveto(x2,y1); lineto(x2,y2);
         end;
       end;
     end;
  3: begin
       x1 := Arect.left;
       x2 := Arect.right;
       For i:= 0 To ah Do
       Begin
         y1 := arect.top + i;
         R := (R1+ (i * R2) div ah) mod 256;
         G := (G1+ (i * G2) div ah) mod 256;
         B := (B1+ (i * B2) div ah) mod 256;
         With ACanvas Do begin
           pen.color:=RGB(R, G, B);
           moveto(x1,y1); lineto(x2,y1);
         end;
       end;
     end;
  4: begin
       x1 := Arect.left;
       x2 := Arect.right;
       ah := ah div 2;
       For i:= 0 To ah Do
       Begin
         y1 := arect.top + cy + i;
         y2 := arect.top + cy - i;
         R := (R1+ (i * R2) div ah) mod 256;
         G := (G1+ (i * G2) div ah) mod 256;
         B := (B1+ (i * B2) div ah) mod 256;
         With ACanvas Do begin
           pen.color:=RGB(R, G, B);
           moveto(x1,y1); lineto(x2,y1);
           moveto(x1,y2); lineto(x2,y2);
         end;
       end;
     end;
  5,6: Begin
       acanvas.brush.style := bsclear;
       acanvas.pen.width := 2;     // vite les trous dans ellipse
       if ah < aw then ah := ah div 2 else ah := aw div 2;
       if radiogroup1.itemindex = 6 then  // multiplier par racine de 2 = 1.4
        ah := ah * 14 div 10;
       for i := 0 to ah do
       begin
          R := (R1+ (i * R2) div ah) mod 256;
          G := (G1+ (i * G2) div ah) mod 256;
          B := (B1+ (i * B2) div ah) mod 256;
          With ACanvas Do begin
           pen.color:=RGB(R, G, B);
           ellipse(cx-i, cy-i, cx+i, cy+i);
         end;
       end;
     end;
  end;
end;

procedure TForm5.FormShow(Sender: TObject);
begin
  degrader(image1.canvas, rect(0,0, 256,256));
end;

end.
