unit Uestamp6;

Interface

Uses Sysutils, Windows, classes;

 Function Power(X, N : real) : extended;
 Procedure FitRect(var arect : Trect;     // rectangle rsultat
                  var azoom : single;    // facteur de zoom utilis
                  Wdest, Hdest,          // dimensions rectangle destimation
                  Worig, Horig,          // dimensions rectangle origine
                  aMargex, aMargey : integer;  // marges rect destimnation
                  agrandir : boolean);

implementation

type
   EPowerException = class(Exception)
end;

function Power(X, N : real) : extended;
var
  t : longint;
  r : real;
  isInteger : boolean;
begin
   if N = 0 then begin result := 1.0;  exit;  end;
   if X = 1.0 then begin result := 1.0;  exit; end;
   if X = 0.0 then
   begin
     if N > 0.0 then
     begin
       result := 0.0;
       exit;
     end
     else
       raise EPowerException.Create('Infinite Result');
     end;
     if (X > 0) then
     try
       result := exp(N * ln(X));
       exit;
     except
       raise EPowerException.Create('Overflow/Underflow Result');
     end;
     { X is negative but we still may compute the result if n is an integer}
     { try and get integer portion of n into a longint, it will be quicker to}
     { compute odd n}
     try
       t := trunc(n);
       if (n - t) = 0 then isInteger := true else isInteger := False;
     except
       {Bit superfluous as result will probably underflow/overflow anyway}
       r := int(n);
       if (n - r) = 0 then
       begin
         isInteger := true;
         if frac(r/2) = 0.5 then t := 1 else t := 2;
       end
       else
       isInteger := False;
    end;
    if isInteger then
    begin  {n is an integer}
      if odd(t) then {n is odd}
      try
        result := -exp(N * ln(-X));
        exit;
      except
        raise EPowerException.Create('Overflow/Underflow Result');
      end
      else         {n is even}
      try
        result := exp(N * ln(-X));
        exit;
      except
        raise EPowerException.Create('Overflow/Underflow Result');
      end;
    end
  else
  raise EPowerException.Create('Complex Result');
end;

// placement d'une image dans une autre avec respect des proportions
Procedure FitRect(var arect : Trect;     // rectangle rsultat
                  var azoom : single;    // facteur de zoom utilis
                  Wdest, Hdest,          // dimensions rectangle destimation
                  Worig, Horig,          // dimensions rectangle origine
                  aMargex, aMargey : integer;  // marges rect destimnation
                  agrandir : boolean);
var
  kw, kh : single;
  wd, hd, wo, ho : single;
  w , h : integer;
begin
  if (worig < 1) or (horig < 1) or (wdest < 1) or (hdest < 1) then
  begin        // protection division par 0 ou dimensions ngatives
    arect.left   := 0;
    arect.top    := 0;
    arect.right  := 0;
    arect.bottom := 0;
    azoom := 1;
    exit;
  end;
  // cas image origine plus petite sans agrandissement
  if (agrandir = false) and
     (worig <= wdest-amargex*2) and (horig <= hdest-amargey*2) then
  begin
    w := worig;
    h := horig;
    azoom := 1;
  end
  else
  begin
    wd := wdest - amargex*2;
    hd := hdest - amargey*2;
    wo := worig;
    ho := horig;
    kw := wd / wo;
    kh := hd / ho;
    // on choisit le plus petit coefficient multiplicateur
    if kw < kh then azoom := kw else azoom := kh;
    w := round(wo*azoom);
    h := round(ho*azoom);
  end;
  arect := bounds((wdest-w) div 2, (hdest-h) div 2, w, h);
end;

end.
 