// unit de lecture images BMP et JPEG
// jean Yves Quinec  28/10/2000  j.y.q@wanadoo.fr
unit Ulecture;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, JPEG, StdCtrls, Buttons, ExtCtrls, FileCtrl, ComCtrls;

type
  TForm3 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    FileListBox1: TFileListBox;
    Image1: TImage;
    Label1: TLabel;
    procedure FileListBox1Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DriveComboBox1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
     function DiskInDrive(Drive: Char): Boolean;
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

uses UEstamp1;   // pour Bmp0

{ teste si device prsent }
function Tform3.DiskInDrive(Drive: Char): Boolean;
var
  ErrorMode: word;
begin
  if Drive in ['a'..'z'] then Dec(Drive, $20);  // en majuscules
  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
  try
    if DiskSize(Ord(Drive) - $40) = -1 then
      Result := False
    else
      Result := True;
  finally
    SetErrorMode(ErrorMode);
  end;
end;

{ slectionne un fichier et affiche image rduite avec proportions correctes }
procedure TForm3.FileListBox1Click(Sender: TObject);
const
  K = 136;
Var
  w0, h0 : single;
  w, h   : single;
  kk : single;
begin
  IF filelistbox1.items.count < 1 then exit;
  IF filelistbox1.filename = '' then exit;
  IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
  Image1.visible := false;
  Image1.width  := K;
  Image1.height := K;
  try
    Image1.Picture.LoadFromFile(FileListbox1.Filename);
  except
    on EInvalidGraphic do
    begin
      Image1.Picture.Graphic := nil;
      exit;
    end;
  end;
  w0 := Image1.picture.graphic.width;
  h0 := Image1.picture.graphic.height;
  Bmp0.free;
  Bmp0 := Tbitmap.create;
  bmp0.width  := Image1.picture.graphic.width;
  bmp0.height := Image1.picture.graphic.height;
  bmp0.canvas.draw(0,0,Image1.picture.graphic);
  w := w0;
  h := h0;
  // ajustement de la taille de image1 (stretched) aux limites 192
  IF (w0 > K) OR (h0 > K) then
  begin
    KK := K;
    IF w0 > h0 then
    begin
      w := kk;
      h := (kk * h0) / w0;
    end
    else
    begin
      h := kk;
      w := (kk*w0) / h0;
    end;
  end;
  Image1.width  := trunc(w);
  Image1.height := trunc(h);

  Label1.caption := 'Taille '+inttostr(bmp0.width) +' x ' +Inttostr(bmp0.height);
  // centrage de Image1 dans panel5
  Image1.left := (Panel1.width  - Image1.width ) div 2;
  Image1.top  := (Panel1.height - Image1.height) div 2;
  Image1.visible := true;
end;

procedure TForm3.DirectoryListBox1Change(Sender: TObject);
begin
  IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
  Filelistbox1.Itemindex := 0;
  Filelistbox1click(sender);
  Filelistbox1.setfocus;
end;

procedure TForm3.DriveComboBox1Click(Sender: TObject);
begin
 IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
end;

procedure TForm3.FormActivate(Sender: TObject);
var
  sv : integer;
begin
  IF refreshdir then
  begin
    sv := filelistbox1.itemindex;
    filelistbox1.update;
    refreshdir := false;
    if filelistbox1.items.count > 0 then
    begin
      if sv < 0 then sv := 0;
      if sv > filelistbox1.items.count-1 then sv := filelistbox1.items.count-1;
      filelistbox1.itemindex := sv;
      if filelistbox1.items.count > 1 then filelistbox1.topindex :=
       filelistbox1.itemindex -1;
      Filelistbox1click(sender);
      Filelistbox1.setfocus;
    end;
  end
  else
  begin
    if firsttime then  Filelistbox1.Itemindex := 0;
    if filelistbox1.items.count > 1 then filelistbox1.topindex :=
       filelistbox1.itemindex -1;
    Filelistbox1click(sender);
    Filelistbox1.setfocus;
  end;
end;

end.
